<?php
class Application_Model_Url {
	protected $_id;
	protected $_url;
	protected $_source;
	
	public function __construct(array $options = null) {
		if (is_array($options)) {
			$this->setOptions($options);
		}
	}
	
	public function __set($name, $value) {
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid property');
		}
		$this->$method($value);
	}
	
	public function __get($name) {
		$method = 'get' . $name;
		
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid property');
		}
		return $this->$method();
		}

	public function setOptions(array $options) {
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	public function setUrl($url) {
		$this->_url = (string) $url;
		return $this;
	}
	public function getUrl() {
		return $this->_url;
	}
	
	public function setSource($source) {
		$this->_source = (string) $source;
		return $this;
	}

	public function getSource() {
		return $this->_source;
	}

	
	public function getId() {
		return $this->_id;
	}
	
	public function setId($id) {
		$this->_id = (int) $id;
		return $this;
	}
}