<?php
class Application_Model_UrlMapper {
	protected $_dbTable;
	
	public function setDbTable($dbTable) {
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;

		
		return $this;
		}
	public function getDbTable() {
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_Url');
		}
		return $this->_dbTable;
	}
	
	public function deleteOne($id) {
		$this->getDbTable()->delete('id = '. (int)$id);
	}
	
	public function save(Application_Model_Url $url) {
		$data = array(
				'url' => $url->getUrl(),
				'source' => $url->getSource()
				);
		if (null === ($id = $url->getId())) {

			unset($data['id']);
			
			$id = $this->getDbTable()->insert($data);
		} else {
			$this->getDbTable()->update($data, array('id = ?' => $id));
		}
		return $id;
	}

	public function find($id, Application_Model_News $news) {
		$result = $this->getDbTable()->find($id);
		if (0 == count($result)) {
			return;
		}
		$row = $result->current();
		$news->setId($row->id)
			->setTitle($row->title)
			->setDescription($row->description);
		}
	
	public function fetchAll() {
		$results = $this->getDbTable()->fetchAll();
		$entries = array();
		foreach ($results as $row) {
			$entry = new Application_Model_Url();
			$entry->setId($row->id)
			->setUrl($row->url)
			->setSource($row->source);
			$entries[] = $entry;
		}
	return $entries;
	}
}