<?php
/**
 * Zend Framework Bootstrap code from listing B.2 here
 */
require_once 'HTTP/Request2.php';


$module_id = 4;
$tasks = $db->fetchall("SELECT * FROM mag2_tasks WHERE task_state NOT LIKE 'CORE_COMPLETE'");
$data = array();

foreach($tasks as $task){
	$request = new HTTP_Request2('https://mag2.norman.com/rapi/tasks/'.$task['task_id'].'');
	$request->setMethod(HTTP_Request2::METHOD_GET)
			->setConfig(array('ssl_verify_peer' => false));

	try {
		$response = $request->send();
		if (200 == $response->getStatus()) {
			$mag2 = json_decode($response->getBody());
			print_r($mag2);
			$data['task_state'] = $mag2->results[0]->task_state_state;
			var_dump($data);			
			
		} else {
			echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
					$response->getReasonPhrase();
		}
	} catch (HTTP_Request2_Exception $e) {
		echo 'Error: ' . $e->getMessage();
	}
	
	if($data['task_state'] == 'CORE_COMPLETE'){
		$db->update('mag2_tasks',
			array('task_state' => 'CORE_COMPLETE'), 'task_id = '. $task['task_id']);
		
		$request = new HTTP_Request2('https://mag2.norman.com/rapi/tasks/'.$task['task_id'].'/events');
		$request->setMethod(HTTP_Request2::METHOD_GET)
		->setConfig(array('ssl_verify_peer' => false));
		
		try {
			$response = $request->send();
			if (200 == $response->getStatus()) {
				$mag2 = json_decode($response->getBody());

			} else {
				echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
				$response->getReasonPhrase();
			}
		} catch (HTTP_Request2_Exception $e) {
			echo 'Error: ' . $e->getMessage();
		}

		
		$request = new HTTP_Request2('https://mag2.norman.com/rapi/tasks/'.$task['task_id'].'/resources');
		$request->setMethod(HTTP_Request2::METHOD_GET)
				 ->setConfig(array('ssl_verify_peer' => false));
		
		try {
			$response = $request->send();
			if (200 == $response->getStatus()) {
				$mag2 = json_decode($response->getBody());
				
				$data['images'] = array();
				foreach($mag2->results as $result){
					if($result->sample_magic_magic_id == 4){ // PNG
						$img = array('id' =>$result->task_resources_resource_id,
									'name' => $result->task_resources_file_name);
						$data['images'][] = $img;
					}
				}
					
			} else {
				echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
						$response->getReasonPhrase();
			}
		} catch (HTTP_Request2_Exception $e) {
			echo 'Error: ' . $e->getMessage();
		}
		
		foreach($data['images'] as $img ) {
			
			$request = new HTTP_Request2 ( 'https://mag2.norman.com/rapi/resources/' . $img['id'] . '/bin' );
			$request->setMethod ( HTTP_Request2::METHOD_GET )->setConfig (array ('ssl_verify_peer' => false ));
			
			try {
				$response = $request->send();
				if (200 == $response->getStatus()) {

					file_put_contents('imgs/'.$img['name'], $response->getBody());
					

				} else {
					echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' . $response->getReasonPhrase();
				}
			} catch(HTTP_Request2_Exception $e) {
				echo 'Error: ' . $e->getMessage();
			}
		
		}
	}

}



?>