<?php
/**
 * Zend Framework Bootstrap code from listing B.2 here
 */
require_once 'Net/URL2.php';
require_once "Net/Ping.php";
require_once "Net/DNS2.php";
require_once 'Net/CheckIP2.php';

$module_id = 8;

$urls = $db->fetchall("SELECT * FROM url_analysis_queue WHERE module_id = ".$module_id." ORDER BY id LIMIT 5000");

foreach($urls as $url){
	switch($url['url_src']){
		case '1':
			$u = 'http://'.$url['url'];
		case '3':
			$u = 'http://'.$url['url'];
		default:
			$u = $url['url'];
	}
	
	$data = array('url_id' => $url['url_id']);
	
	$url2 = &new Net_URL2($u);
	$host = $url2->host;

	$ip = 0;
	if (Net_CheckIP2::isValid($host)) {
		$data['ip'] = $host;
		$data['fqdn'] ='';
		$data['destfqdn'] = '';
	} else {
		$r = new Net_DNS2_Resolver();
		
		try {
			$result = $r->query($url2->host);
			// in some cases domains may point to a cname which points to a new cname which points to a new cname etc...
			// cname -> cname -> cname -> ... -> cname -> a -> ip
			// not usual, but may happen. We choose to only store the first cname and the last a -> ip
			// Net_DNS2_Resolver gives us a result array consisting what we need:
			$i = 0;
			foreach($result->answer as $rr){
				if($i == 0 && $rr->type == "CNAME"){ // the fqdn from the url
					$data['fqdn'] = $rr->name;
				}
				if($rr->type == "A"){
					$data['ip'] = $rr->address;
					$data['fqdn'] = !isset($data['fqdn']) ? $rr->name : $data['fqdn']; // fqdn = destfqdn for just A records
																						// we do not want to overwrite CNAME's
					$data['destfqdn'] = $rr->name;
					break;
				}
				$i++;
			}
		} catch(Net_DNS2_Exception $e) {
			echo "::query() failed: ", $e->getMessage(), "\n";
			$data['fqdn'] = $url2->host;
			$data['ip'] = 0;
			$data['destfqdn'] = '';
			$data['up'] = false;
		
		}


		
}
if($data['ip'] != 0){

	$ping = Net_Ping::factory();
	if (PEAR::isError($ping)) {
		echo $ping->getMessage();
	} else {
		$matches = array();
		$severely = true;
		$ping->setArgs(array(
				"count" => 1,
				"size"  => 32,
				"quiet" => null)
		);
		$res = $ping->ping($data['ip']);
		//print_r($res);

		$data['up'] = true;

		if(PEAR::isError($res)) {
			$data['up'] = false;
		}

		if($res->_received == 0) {
			$data['up'] = false;
		}

		if($res->_received != $res->_transmitted && $severely) {
			$data['up'] = false;

		}
	}
} else {
	$data['up'] = false;
}		
$data['ip'] = ip2long($data['ip']);
$db->insert('ip_domain', $data);
	$db->delete('url_analysis_queue',
	array('url_id = ?' 	   => $data['url_id'],
			'module_id = ? ' => $module_id)
	);
}
?>

